function Qd=decluster(Q,s,m,n)
% not used in rmpc v3.0
% this function tries to decluster a clustered set of constraints that are sometimes obtained
% by selecting eps-active constraints on descretized semiinfinite problems for example
% inputs/outpus are self-explainatory

Q=Q(:);
Qsort=sort(Q);
mQ=length(Q);

%always keep the m most active
[ssort,isort]=sort(s);
Qd=isort(1:m);
%Qd=[];

dQsort=diff(Qsort);
iclust=[0;find(dQsort>1);mQ]; %edges of the clusters
mclust=length(iclust)-1; %number of clusters
kclust=1;%ceil(mclust-1/m); %number of elements to select from each cluster


for i=1:mclust
    Qi=Qsort(iclust(i)+1:iclust(i+1));
    [si,isorti]=sort(s(Qi));
    Qd=union(Qd, Qi(isorti(1:min(length(Qi),kclust))));
end
